!!ARBfp1.0

# Fragment inputs
ATTRIB inTexCoord = fragment.texcoord[0];      # First set of texture coordinates
ATTRIB inColor    = fragment.color.primary; # Diffuse interpolated color

PARAM black = {0.0, 0.0, 0.0, 0.0};
PARAM white = {1.0, 1.0, 1.0, 1.0};
PARAM gray = {0.3, 0.59, 0.11, 0.0};  # correct grayscale conversion
#PARAM gray = {0.3, 0.2, 0.5, 0.0};     # hacked grayscale conversion for our scene :)
#PARAM offset = {0.1, 0.1, 0.1, 0.1};   # min. value of color difference so we call it an edge
PARAM offset = {0.05, 0.05, 0.05, 0.05};   # min. value of color difference so we call it an edge

TEMP foo, bar;
TEMP gray0, gray1, gray2, gray3, gray4, diff, diff2, diffsq, diffsq1, diffsq2, oneminusdiffsq;
TEMP texelColor, texelColor1, texelColor2, texelColor3, texelColor4;
TEMP int;

# Fragment outputs
OUTPUT outColor   = result.color;

TEX texelColor, inTexCoord, texture, 2D;       # sample current texture
TEX texelColor1, fragment.texcoord[1], texture, 2D;  # sample texture coords around current frag
TEX texelColor2, fragment.texcoord[2], texture, 2D;  # 
TEX texelColor3, fragment.texcoord[3], texture, 2D;  # 
TEX texelColor4, fragment.texcoord[4], texture, 2D;  # 

DP4 gray0, texelColor, gray;   # convert to grayscale 
DP4 gray1, texelColor1, gray;   # convert to grayscale 
DP4 gray2, texelColor2, gray;   
DP4 gray3, texelColor3, gray;   
DP4 gray4, texelColor4, gray;   

SUB diff.x, gray1.x, gray2.x;     
SUB diff.y, gray1.x, gray3.x;    
SUB diff.z, gray1.x, gray4.x;     
SUB diff2.x, gray2.x, gray3.x;     
SUB diff2.y, gray2.x, gray4.x;     
SUB diff2.z, gray3.x, gray4.x;     

MUL diffsq1, diff, diff;         # square to get abs value
MUL diffsq2, diff2, diff2;        # square to get abs value

MAX diffsq, diffsq1, diffsq2;

# everything should be black, except - see below
MUL foo, foo, black;

# if brightness gradient is less than offset: not an edge, so white
SLT foo.xyz, diffsq.x, offset.x;
SLT foo.xyz, diffsq.y, offset.x;
SLT foo.xyz, diffsq.z, offset.x;

MUL foo, texelColor, foo;  # Modulate texel color with vertex color   

TEX int, gray0.x, texture[1], 1D;

RCP gray0, gray0.x;
MUL int, gray0, int;
MUL foo, foo, int;

MOV outColor, foo;
END


