!!ARBvp1.0

# Constant Parameters
PARAM mvp[4] = { state.matrix.mvp }; # Model-view-projection matrix

# Per-vertex inputs
ATTRIB inPosition = vertex.position;
ATTRIB inColor    = vertex.color;
ATTRIB inTexCoord = vertex.texcoord[0];

# Per-vertex outputs
OUTPUT outPosition = result.position;
OUTPUT outColor    = result.color;
OUTPUT outTexCoord = result.texcoord[0];

DP4 outPosition.x, mvp[0], inPosition;   # Transform the x component of the per-vertex position into clip-space
DP4 outPosition.y, mvp[1], inPosition;   # Transform the y component of the per-vertex position into clip-space
DP4 outPosition.z, mvp[2], inPosition;   # Transform the z component of the per-vertex position into clip-space
DP4 outPosition.w, mvp[3], inPosition;   # Transform the w component of the per-vertex position into clip-space

MOV outColor, inColor;       # Pass the color through unmodified
MOV outTexCoord, inTexCoord; # Pass one copy of the texcoords through unmodified
ADD result.texcoord[1], inTexCoord, { 0.002, 0.001, 0, 1 };   # add offset texture coords
ADD result.texcoord[2], inTexCoord, { -0.002, -0.001, 0, 1 }; # needed for edge detection
ADD result.texcoord[3], inTexCoord, { 0.002, -0.001, 0, 1 };   # add offset texture coords
ADD result.texcoord[4], inTexCoord, { -0.002, 0.001, 0, 1 }; # needed for edge detection

END
